StatementFacade (Apache Tomcat 11.0.25 API Documentation)
Description: declaration: package: org.apache.tomcat.jdbc.pool, class: StatementFacade

# Class StatementFacade

java.lang.Object
org.apache.tomcat.jdbc.pool.JdbcInterceptor
org.apache.tomcat.jdbc.pool.interceptor.AbstractCreateStatementInterceptor
org.apache.tomcat.jdbc.pool.StatementFacade

All Implemented Interfaces:
  `InvocationHandler`

public class StatementFacade extends AbstractCreateStatementInterceptor
Facade that creates statement and result set proxies.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `StatementFacade.ResultSetProxy`
  Proxy for a ResultSet.
  `protected class`
  `StatementFacade.StatementProxy`
  Proxy for a SQL statement used to measure query execute time.

- ## Field Summary

  ### Fields inherited from class AbstractCreateStatementInterceptor

  `constructors, CREATE_STATEMENT, CREATE_STATEMENT_IDX, EXECUTE, EXECUTE_BATCH, EXECUTE_QUERY, EXECUTE_TYPES, EXECUTE_UPDATE, GET_GENERATED_KEYS, GET_RESULTSET, GET_STATEMENT, PREPARE_CALL, PREPARE_CALL_IDX, PREPARE_STATEMENT, PREPARE_STATEMENT_IDX, RESULTSET_IDX, STATEMENT_TYPE_COUNT, STATEMENT_TYPES`

  ### Fields inherited from class JdbcInterceptor

  `CLOSE_VAL, EQUALS_VAL, GETCONNECTION_VAL, HASHCODE_VAL, ISCLOSED_VAL, ISVALID_VAL, ISWRAPPERFOR_VAL, properties, TOSTRING_VAL, UNWRAP_VAL`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `StatementFacade(JdbcInterceptor interceptor)`
  Constructs a StatementFacade.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `closeInvoked()`
  Method invoked when the operation `Connection.close()` is invoked.
  `Object`
  `createStatement(Object proxy, Method method, Object[] args, Object statement, long time)`
  Creates a statement interceptor to monitor query response times

  ### Methods inherited from class AbstractCreateStatementInterceptor

  `getConstructor, invoke, isExecute, isStatement, process, reset`

  ### Methods inherited from class JdbcInterceptor

  `compare, compare, disconnected, getNext, getProperties, isUseEquals, poolClosed, poolStarted, setNext, setProperties, setUseEquals`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### StatementFacade

    protected StatementFacade(JdbcInterceptor interceptor)
    Constructs a StatementFacade.
    Parameters:
      `interceptor` - the next interceptor in the chain

- ## Method Details

  - ### closeInvoked

    public void closeInvoked()
    Description copied from class: `AbstractCreateStatementInterceptor`
    Method invoked when the operation `Connection.close()` is invoked.
    Specified by:
      `closeInvoked` in class `AbstractCreateStatementInterceptor`

  - ### createStatement

    public Object createStatement(Object proxy, Method method, Object[] args, Object statement, long time)
    Creates a statement interceptor to monitor query response times
    Specified by:
      `createStatement` in class `AbstractCreateStatementInterceptor`
    Parameters:
      `proxy` - the actual proxy object
      `method` - the method that was called. It will be one of the methods defined in `AbstractCreateStatementInterceptor.STATEMENT_TYPES`
      `args` - the arguments to the method
      `statement` - the statement that the underlying connection created
      `time` - Elapsed time
    Returns:
      a `Statement` object